local msqrt = math.sqrt
local status = { jit.status ( ) }
local ffi = require ( "ffi" )

local vec2 = { }
vec2.__index = vec2

function vec2:add ( v )
	self.x = self.x + v.x
	self.y = self.y + v.y
end
function vec2:norm ( )
	local l = 1 / msqrt ( self.x * self.x + self.y * self.y )
	self.x = self.x * l
	self.y = self.y * l
end

ffi.cdef ( "typedef struct vec2 { float x, y; } vec2;" )
vec2.new = ffi.typeof ( "vec2" )
ffi.metatype ( "vec2", vec2 )

local tf1 = function ( )
	local v1, v2 = vec2.new ( 1, 1 ), vec2.new ( 2, 3 )
	local t = love.timer.getTime ( )
	for i = 1, 100000 do
		v1:add ( v2 )
		v1:norm ( )
	end
	t = love.timer.getTime ( ) - t
	return t
end

local t1, t2

function love.load ( )
	t1 = tf1 ( )
	jit.on ( )
	t2 = tf1 ( )
end

function love.draw ( )
	love.graphics.print  ( tostring ( status[ 1 ] ) .. "\n" .. t1 .. "\n" .. t2, 10, 10 )
	for i = 2, #status do
		love.graphics.print ( status[ i ], 200, i * 20 )
	end
end
